#include "xgrafi.h"


#ifndef Objetos_h
#define Objetos_h

class Objetos
{
	public:
//	virtual void Dibujar(){};
};


//_______________Xboton________________________________________
class Xboton 
{
  public:
	Xboton(int xi, int yi,int ancho,int alto,char *texto);
	Xboton(int xi, int yi, char *texto);
	void SetLabel(char *texto);
	bool get(int xi, int yi);	
	int ValorX(void);
	int ValorY(void);
	char * ValorS(void);
	void Move(int xm,int ym);
	void Visible(bool v1);
  protected:
		int x,y,xx,yy;
		char name[20];	
		bool estado;
		bool visible;
		
};
//__________BOTON____________________

class Boton : public Xboton
{
  public:
	Boton(int xi, int yi,int ancho,int alto,char *texto);
	Boton(int xi, int yi, char *texto);
	void Dibujar(bool s=0);		//1 pulsado, 0 no pulsado
	char *Valor(void);
};



//______CBOTON_________________
class CBoton : public  Xboton
{
  public:
	CBoton(int xi, int yi,int ancho,int alto,char *texto);
	CBoton(int xi, int yi, char *texto);
	void Dibujar();
	void SetValue(bool s);
	bool GetValue(void);
	char *Valor(void);	
};



//_______CHEQUEO__________
class Chequeo : public Objetos
{
  public:
	Chequeo(int xi, int yi, char *texto);
	Chequeo(int xi, int yi, char *texto, bool estadoi);
	void Dibujar();
	bool get(int xi, int yi);
	void set(bool s);
	bool value(void);
	void Text(char *texto);
	char *Valor(void);	
	int ValorX(void);
	int ValorY(void);
	char * ValorS(void);
	void Move(int xm,int ym);	
  private:
		int x,y,xx,yy;
		bool estado;
		char name[20];	
};

//________TEXT Static______________
class TextoS : public Objetos
{
  public:
	TextoS(int xi, int yi, char *texto);
	void Dibujar();	
	void DibujarColor();
	bool get(int xi, int yi);
	void Text(char *texto);
	char *Valor(void);	
	int ValorX(void);
	int ValorY(void);
	char * ValorS(void);
	void Move(int xm,int ym);
  private:
		int x,y;
		char name[20];	
};


//____________EDIT TEXT____________
class TextoE : public Objetos
{
  public:
	TextoE(int xi, int yi, char *texto);
	TextoE(int xi, int yi, int ancho, int alto, char *texto);
	void Value(int n);
	void Value(float n);
	void Value(char *texto);
	void Dibujar();
	bool get(int xi, int yi);
	void Text(char *texto);
	char *Valor(void);	
	int ValorX(void);
	int ValorY(void);
	char * ValorS(void);
	void Move(int xm,int ym);
  private:
		int x,y,xx,yy;
		char name[20];	
};


//____________SpinBox_Numero___________
class SpinBox : public Objetos
{
  public:
	SpinBox(int xi, int yi, int anchoi, int altoi, int mini, int maxi, int increi);
	SpinBox(int xi, int yi);
	void SetValue(int n);
	int GetValue();
	void Increm();
	void Decrem();
	void Dibujar();
	unsigned char get(int xi, int yi);
	char *Valor(void);	
	int ValorX(void);
	int ValorY(void);
	void Move(int xm,int ym);
  private:
		int x,y,xx,yy,max,min,incre,valor;
};

//____________SpinBox_Static____________
class SpinBoxS : public Objetos
{
  public:
	SpinBoxS(int xi, int yi, int anchoi, int altoi);
	SpinBoxS(int xi, int yi);
	void SetValue(int n);
	int GetValue();
	void Increm();
	void Decrem();
	void Dibujar();
	unsigned char get(int xi, int yi);
	void Append(char *texto);
	char *Valor(void);	
	int ValorX(void);
	int ValorY(void);
	void Move(int xm,int ym);
  private:
		int x,y,xx,yy,max,min,incre,valor;
		char *name[15];
};

//____________SpinBox_Dinamic____________
class SpinBoxD : public Objetos
{
  public:
	SpinBoxD(int xi, int yi, int anchoi, int altoi);
	SpinBoxD(int xi, int yi);
	void SetValue(int n);
	int GetValue();
	void Increm();
	void Decrem();
	void Dibujar();
	unsigned char get(int xi, int yi);
	void Append(char *texto);
	char *Valor(void);	
	int ValorX(void);
	int ValorY(void);
	void Move(int xm,int ym);
  private:
		int x,y,xx,yy,max,min,incre,valor;
		char name[15][20];
};


#endif
