#include <string.h>

#include "objetos.h"
#include "xgrafi.h"

char cadena[100];

//____________SpinBoxD____________
	SpinBoxD::SpinBoxD(int xi, int yi, int anchoi, int altoi)
	{
	 int z;
		for(z=0;z<15;z++) name[z][0]=0;
		x=xi; y=yi; xx=x+anchoi;  yy=y+altoi; valor=0;
	}
	SpinBoxD::SpinBoxD(int xi, int yi)
	{
	 int z;
		for(z=0;z<15;z++) name[z][0]=0;
		x=xi; y=yi; xx=x+100;  yy=y+24;	 valor=0;
	}
	void SpinBoxD::SetValue(int n)
	{
		valor=n;
	}
	int SpinBoxD::GetValue()
	{
		return(valor);
	}
	void SpinBoxD::Increm()
	{	
	 int z;
		for(z=0;z<15 && name[z][0]!=0 ;z++) ;	
		if(valor<z-1) valor++;
	}
	void SpinBoxD::Decrem()
	{
		if(valor>0) valor--;
	}
	void SpinBoxD::Append(char *texto)
	{
	 int z;
		for(z=0;z<15;z++) 
			if(name[z][0]==0)
				{				
				 strncpy(&name[z][0],texto,19);
				 break;
				}
	}
	void SpinBoxD::Dibujar()
	{
		SDL_Surface *message;
		char temp[20];
			if(name[valor][0]==0) return;
			sprintf(temp,"%s",&name[valor][0]);
			
			setcolor(150,150,255);	 	bar(x,y,xx,yy);
		 	setcolor(0,0,0);	box(x,y,xx,yy);	
		 	line(x+18,y,x+18,yy); 
		 	line(x,y+(yy-y)/2,x+18,y+(yy-y)/2);
		 	
		 	line(x,y+(yy-y)/2,x+9,y); 	line(x+9,y,x+18,y+(yy-y)/2);
		 	line(x,y+(yy-y)/2,x+9,yy);  line(x+9,yy,x+18,y+(yy-y)/2);
		 	
			message = TTF_RenderText_Solid( font,temp, textColor );	
			apply_surface( x+20, y+2, message, screen );
	}
	unsigned char SpinBoxD::get(int xi, int yi)
	{
		if(xi>x && xi<x+20 && yi>y && yi<yy-(yy-y)/2)	 return(1);
			if(xi>x && xi<x+20 && yi>yy-(yy-y)/2 && yi<yy) return(2);
			return(0);
	}
	char *  SpinBoxD::Valor(void)
			{		
				sprintf(cadena,"new SpinBoxD(%d,%d,70,24);",x,y);
				return(cadena);
			}
	int  SpinBoxD::ValorX(void)	{ return(x); }	
	int  SpinBoxD::ValorY(void)	{ return(y); }
	void SpinBoxD::Move(int xm,int ym)
		{
			xx=(xx-x)+xm;  yy=(yy-y)+ym;
			x=xm; y=ym; 
		}
	



//____________SpinBoxS____________
	SpinBoxS::SpinBoxS(int xi, int yi, int anchoi, int altoi)
	{
	 int z;
		for(z=0;z<15;z++) name[z]=NULL;
		x=xi; y=yi; xx=x+anchoi;  yy=y+altoi; valor=0;
	}
	SpinBoxS::SpinBoxS(int xi, int yi)
	{
	 int z;
		for(z=0;z<15;z++) name[z]=NULL;
		x=xi; y=yi; xx=x+100;  yy=y+24;	 valor=0;
	}
	void SpinBoxS::SetValue(int n)
	{
		valor=n;
	}
	int SpinBoxS::GetValue()
	{
		return(valor);
	}
	void SpinBoxS::Increm()
	{	
	  int z;
		for(z=0;z<15 && name[z]!=NULL ;z++) ;	
		if(valor<z-1) valor++;
	}
	void SpinBoxS::Decrem()
	{
		if(valor>0) valor--;
	}
	void SpinBoxS::Append(char *texto)
	{
	 int z;
		for(z=0;z<15;z++) 
			if(name[z]==NULL)
				{
				 name[z]=texto;	
				 break;
				}
	}
	void SpinBoxS::Dibujar()
	{
		SDL_Surface *message;
		  char temp[20];
		    if(name[valor]==NULL) return;
			sprintf(temp,"%s",name[valor]);
			setcolor(150,150,255);	 	bar(x,y,xx,yy);
		 	setcolor(0,0,0);	box(x,y,xx,yy);	
		 	line(x+18,y,x+18,yy); 
		 	line(x,y+(yy-y)/2,x+18,y+(yy-y)/2);
		 	
		 	line(x,y+(yy-y)/2,x+9,y); 	line(x+9,y,x+18,y+(yy-y)/2);
		 	line(x,y+(yy-y)/2,x+9,yy);  line(x+9,yy,x+18,y+(yy-y)/2);
		 	
			message = TTF_RenderText_Solid( font,temp, textColor );	
			apply_surface( x+20, y+2, message, screen );
	}
	unsigned char SpinBoxS::get(int xi, int yi)
	{
		if(xi>x && xi<x+20 && yi>y && yi<yy-(yy-y)/2)	 return(1);
			if(xi>x && xi<x+20 && yi>yy-(yy-y)/2 && yi<yy) return(2);
			return(0);
	}
	char *  SpinBoxS::Valor(void)
			{		
				sprintf(cadena,"new SpinBoxS(%d,%d,70,24);",x,y);
				return(cadena);
			}
	int  SpinBoxS::ValorX(void)	{ return(x); }	
	int  SpinBoxS::ValorY(void)	{ return(y); }
	void SpinBoxS::Move(int xm,int ym)
		{
			xx=(xx-x)+xm;  yy=(yy-y)+ym;
			x=xm; y=ym; 
		}
	


//____________SpinBox____________

	SpinBox::SpinBox(int xi, int yi, int anchoi, int altoi, int mini, int maxi, int increi)
		{
			x=xi; y=yi; xx=x+anchoi;  yy=y+altoi; 
			max=maxi;  min=mini; incre=increi; valor=mini;
		}
	SpinBox::SpinBox(int xi, int yi)
		{
			x=xi; y=yi; xx=x+50;  yy=y+24; 
			max=10;  min=0; incre=1; valor=0;
		}
	void SpinBox::SetValue(int n)
		{
			valor=n;
		}
	int SpinBox::GetValue()
		{
			return(valor);
		}
	unsigned char SpinBox::get(int xi, int yi)
		{
			if(xi>x && xi<x+20 && yi>y && yi<yy-(yy-y)/2)	 return(1);
			if(xi>x && xi<x+20 && yi>yy-(yy-y)/2 && yi<yy) return(2);
			return(0);
		}
	void SpinBox::Increm()
		{
			valor+=incre;
			if(valor>max) valor=max;
		}
	void SpinBox::Decrem()
		{
			valor-=incre;
			if(valor<min) valor=min;
		}
	void SpinBox::Dibujar()
		{
		  SDL_Surface *message;
		  char temp[20];
			sprintf(temp,"%d",valor);
			setcolor(200,150,255);	 	bar(x,y,xx,yy);
		 	setcolor(0,0,0);	box(x,y,xx,yy);	
		 	line(x+18,y,x+18,yy); 
		 	line(x,y+(yy-y)/2,x+18,y+(yy-y)/2);
		 	
		 	line(x,y+(yy-y)/2,x+9,y); 	line(x+9,y,x+18,y+(yy-y)/2);
		 	line(x,y+(yy-y)/2,x+9,yy);  line(x+9,yy,x+18,y+(yy-y)/2);
		 	
			message = TTF_RenderText_Solid( font,temp, textColor );	
			apply_surface( x+20, y+2, message, screen );
		}
	char *  SpinBox::Valor(void)
			{		
				sprintf(cadena,"new SpinBox(%d,%d,50,24,0,100,1);",x,y);
				return(cadena);
			}
	int  SpinBox::ValorX(void)	{ return(x); }	
	int  SpinBox::ValorY(void)	{ return(y); }
	void SpinBox::Move(int xm,int ym)
		{
			xx=(xx-x)+xm;  yy=(yy-y)+ym;
			x=xm; y=ym; 
		}

//____________EDIT TEXT____________
	TextoE::TextoE(int xi, int yi, char *texto)
		{
			x=xi; y=yi; xx=x+100;  yy=y+24;
			strncpy(name,texto,19);
		}
	TextoE::TextoE(int xi, int yi, int ancho, int alto, char *texto)
		{
			x=xi; y=yi; xx=x+ancho;  yy=y+alto; 
			strncpy(name,texto,19);
		}
	void TextoE:: Value(int n)
		{
			char temp[20];
			sprintf(temp,"%d",n);
			strncpy(name,temp,19);

		}
	void TextoE:: Value(float n)
		{
			char temp[20];
			sprintf(temp,"%.2f",n);
			strncpy(name,temp,19);
		}
	void TextoE:: Value(char *texto){	strncpy(name,texto,19);	}
	void TextoE:: Dibujar()
		{
		  SDL_Surface *message;
			setcolor(200,200,255);	 	bar(x,y,xx,yy);
		 	setcolor(0,0,0);		 	box(x,y,xx,yy);	
			message = TTF_RenderText_Solid( font,name, textColor );	
			apply_surface( x+2, y+2, message, screen );
		}
	bool TextoE::get(int xi, int yi)
		{
			if(xi>x && xi<x+100 && yi>y && yi<y+24)
				return(1);
			else
				return(0);
		}
	void TextoE::Text(char *texto)	{	strncpy(name,texto,19);	}	
	char *  TextoE::Valor(void)
			{		
				sprintf(cadena,"new TextoE(%d,%d,(char*)\"%s\");",x,y,name);
				return(cadena);
			}
	int  TextoE::ValorX(void)		{ return(x);	}	
	int  TextoE::ValorY(void)		{ return(y);	}
	char *  TextoE::ValorS(void)	{ return(name);	}
	void TextoE::Move(int xm,int ym)
		{
			xx=(xx-x)+xm;  yy=(yy-y)+ym;
			x=xm; y=ym; 
		}

//____________TEXTOS____________
	TextoS::TextoS(int xi, int yi, char *texto)
		{
			x=xi; y=yi;
			strncpy(name,texto,19);
		}
	void TextoS:: Dibujar()
		{
		  SDL_Surface *message;
			message = TTF_RenderText_Solid( font,name, textColor );	
			apply_surface( x, y, message, screen );
		}
	void TextoS:: DibujarColor()
		{
		  SDL_Surface *message;
			message = TTF_RenderText_Solid( font,name, ColorDefault );	
			apply_surface( x, y, message, screen );
		}
	bool TextoS::get(int xi, int yi)
		{
			if(xi>x && xi<x+24 && yi>y && yi<y+24)
				return(1);
			else
				return(0);
		}
	void TextoS::Text(char *texto)	{	strncpy(name,texto,19);	}	
	char *  TextoS::Valor(void)
			{		
				sprintf(cadena,"new TextoS(%d,%d,(char*)\"%s\");",x,y,name);
				return(cadena);
			}
	int  TextoS::ValorX(void)		{ return(x);	}	
	int  TextoS::ValorY(void)		{ return(y);	}
	char *  TextoS::ValorS(void)	{ return(name);	}
	void TextoS::Move(int xm,int ym)
			{
				x=xm; y=ym;
			}
							

//____________CHEQUEO____________

	Chequeo::Chequeo(int xi, int yi, char *texto) 
		{
			x=xi; y=yi; xx=x+16;  yy=y+16; estado=0;
			 strncpy(name,texto,19);
		}
	Chequeo::Chequeo(int xi, int yi, char *texto, bool estadoi) 
		{
			x=xi; y=yi; xx=x+16;  yy=y+16; estado=estadoi;
			 strncpy(name,texto,19);
		}
	void Chequeo::Dibujar()
		{
			SDL_Surface *message;
		 	setcolor(230,230,230);	 	bar(x,y,xx,yy);		 	
		 	setcolor(0,0,0);		 	box(x,y,xx,yy);
		 	if(estado==1) { setcolor(255,0,0); bar(x+4,y+4,xx-4,yy-4);	}
		 	message = TTF_RenderText_Solid( font,name, textColor );			
			apply_surface( xx+4, y, message, screen );		 	 			 			 		 	
		}
					
	bool Chequeo::get(int xi, int yi)
		{
			if(xi>x && xi<xx && yi>y && yi<yy)
				return(1);
			else
				return(0);
		}
	void Chequeo::set(bool s)	{ estado=s;	}
	bool Chequeo::value(void)	{ return(estado);	}
	void Chequeo::Text(char *texto)	{	strncpy(name,texto,19);	}	
	char *  Chequeo::Valor(void)
			{		
				sprintf(cadena,"new Chequeo(%d,%d,(char*)\"%s\");",x,y,name);
				return(cadena);
			}
	int  Chequeo::ValorX(void)		{ return(x);	}	
	int  Chequeo::ValorY(void)		{ return(y);	}
	char *  Chequeo::ValorS(void)	{ return(name);	}	
	void Chequeo::Move(int xm,int ym)
			{
				x=xm; y=ym; xx=x+16;  yy=y+16;
			}

//___________Xboton
Xboton::Xboton(int xi, int yi,int ancho,int alto,char *texto) 
		{
			x=xi; y=yi; xx=x+ancho;  yy=y+alto;
			strncpy(name,texto,19);
			visible=1;
		}
Xboton::Xboton(int xi, int yi, char *texto) 
		{
			x=xi; y=yi; xx=x+100;  yy=y+24;
			strncpy(name,texto,19);
			visible=1;
		}		
void Xboton::SetLabel(char *texto)
		{
		 strncpy(name,texto,19);	
		}
bool Xboton::get(int xi, int yi)
		{
			if(xi>x && xi<xx && yi>y && yi<yy)
				return(1);
			else
				return(0);
		}

int  Xboton::ValorX(void)		{ return(x);	}	
int  Xboton::ValorY(void)		{ return(y);	}
char *  Xboton::ValorS(void)	{ return(name);	}
void Xboton::Move(int xm,int ym)
		{
			xx=(xx-x)+xm;  yy=(yy-y)+ym;
			x=xm; y=ym; 
		}
void Xboton::Visible(bool v1) { visible=v1;}
	
				
//____________BOTON____________
	Boton::Boton(int xi, int yi,int ancho,int alto,char *texto) : Xboton(xi,yi,ancho,alto,texto)
		{		}
	Boton::Boton(int xi, int yi, char *texto) : Xboton(xi,yi,texto)
		{		}
	void Boton::Dibujar(bool s)		
		{
			int w1,h1,z;
			SDL_Surface *message;
			if(visible==0) return;
			if(s)  //pulsado
			{
			 setcolor(150,150,150);	 	bar(x,y,xx,yy);
			 setcolor(0,0,0);		 	box(x,y,xx,yy);
			 setcolor(250,250,250);	 	box(x+1,y+1,xx-1,yy-1);
			 setcolor(200,200,200);	 	box(x+2,y+2,xx-2,yy-2);	
			}
			else   //no pulsado
			{
		 	setcolor(230,230,230);	 	bar(x,y,xx,yy);
		 	setcolor(150,150,150);	 	box(x+2,y+2,xx-2,yy-2);
		 	setcolor(100,100,100);	 	box(x+1,y+1,xx-1,yy-1);
		 	setcolor(0,0,0);		 	box(x,y,xx,yy);	
			}
		 	message = TTF_RenderText_Solid( font,name, textColor );
			if(TTF_SizeText(font,name,&w1,&h1))
				{	printf("Error tamaño texto");	} 
				else
				{	z=(xx-x)/2;	w1=w1/2;	w1=z-w1;	if(w1<0)w1=0;	}	
			apply_surface( x+w1, y+2, message, screen );		 	 			 			 		 	
		}
	char *  Boton::Valor(void)
		{		
			sprintf(cadena,"new Boton(%d,%d,%d,%d,(char*)\"%s\");",x,y,xx-x,yy-y,name);
			return(cadena);
		}


//_____________BOTON__CHEQUEO_________
	CBoton::CBoton(int xi, int yi,int ancho,int alto,char *texto) : Xboton(xi,yi,ancho,alto,texto)
		{		}

	CBoton::CBoton(int xi, int yi, char *texto) : Xboton(xi,yi,texto)
		{		}

	void CBoton::Dibujar()
		{
			int w1,h1,z;
			SDL_Surface *message;
			if(estado==1)
			{
				setcolor(230,230,230);	 	bar(x,y,xx,yy);
				setcolor(150,150,150);	 	box(x+2,y+2,xx-2,yy-2);
				setcolor(100,100,100);	 	box(x+1,y+1,xx-1,yy-1);
				setcolor(0,0,0);		 	box(x,y,xx,yy);
			}
		 	else
		 	{
				setcolor(150,150,150);	 	bar(x,y,xx,yy);
				setcolor(0,0,0);		 	box(x,y,xx,yy);
				setcolor(250,250,250);	 	box(x+1,y+1,xx-1,yy-1);
				setcolor(200,200,200);	 	box(x+2,y+2,xx-2,yy-2);	
		 	}
		 	message = TTF_RenderText_Solid( font,name, textColor );
			if(TTF_SizeText(font,name,&w1,&h1))
				{	printf("Error tamaño texto");	} 
				else
				{	z=(xx-x)/2;	w1=w1/2;	w1=z-w1;	if(w1<0)w1=0;	}	
			apply_surface( x+w1, y+2, message, screen );			 	 			 			 		 	
		}
					
	
	void CBoton::SetValue(bool s) {	estado=s;	}
	bool CBoton::GetValue(void)	{	return(estado);	}
	char *  CBoton::Valor(void)
		{		
			sprintf(cadena,"new CBoton(%d,%d,%d,%d,(char*)\"%s\");",x,y,xx-x,yy-y,name);
			return(cadena);
		}

//__________________________
